GDB (xrefs)

Namespaces | Macros | Typedefs | Functions | Variables
offset-type-selftests.c File Reference
`#include "defs.h"`
`#include "selftest.h"`
`#include "common/offset-type.h"`
`#include "common/underlying.h"`
`#include "common/valid-expr.h"`

Go to the source code of this file.

## Namespaces
| selftests
| selftests::offset_type

## Macros
#define | CHECK_VALID(VALID, EXPR_TYPE, EXPR) CHECK_VALID_EXPR_2 (off_A, off_B, VALID, EXPR_TYPE, EXPR)

## Typedefs
using | selftests::offset_type::undrl = std::underlying_type< off_A >::type

## Functions
| selftests::offset_type::DEFINE_OFFSET_TYPE (off_A, unsigned int)
| selftests::offset_type::DEFINE_OFFSET_TYPE (off_B, unsigned int)
| selftests::offset_type::CHECK_VALID (true, off_A, off_A {}+undrl {})
| selftests::offset_type::CHECK_VALID (true, off_A, off_A {} - undrl {})
| selftests::offset_type::CHECK_VALID (true, off_A, undrl {}+off_A {})
| selftests::offset_type::CHECK_VALID (true, off_A, undrl {} - off_A {})
| selftests::offset_type::CHECK_VALID (false, void, off_A {}+off_A {})
| selftests::offset_type::CHECK_VALID (false, void, off_A {}+off_B {})
| selftests::offset_type::CHECK_VALID (false, void, off_B {} - off_A {})
| selftests::offset_type::CHECK_VALID (true, undrl, off_A {} - off_A {})
| selftests::offset_type::CHECK_VALID (false, void, lval_a+=off_A {})
| selftests::offset_type::CHECK_VALID (false, void, lval_a -=off_A {})
| selftests::offset_type::CHECK_VALID (true, off_A &, lval_a+=undrl {})
| selftests::offset_type::CHECK_VALID (true, off_A &, lval_a -=undrl {})
| selftests::offset_type::CHECK_VALID (false, void, off_A {}+=undrl {})
| selftests::offset_type::CHECK_VALID (false, void, off_A {} -=undrl {})
| selftests::offset_type::CHECK_VALID (true, bool, off_A {}< off_A {})
| selftests::offset_type::CHECK_VALID (true, bool, off_A {} > off_A {})
| selftests::offset_type::CHECK_VALID (true, bool, off_A {}<=off_A {})
| selftests::offset_type::CHECK_VALID (true, bool, off_A {} >=off_A {})
| selftests::offset_type::CHECK_VALID (false, void, off_A {}< off_B {})
| selftests::offset_type::CHECK_VALID (false, void, off_A {} > off_B {})
| selftests::offset_type::CHECK_VALID (false, void, off_A {}<=off_B {})
| selftests::offset_type::CHECK_VALID (false, void, off_A {} >=off_B {})
| selftests::offset_type::CHECK_VALID (false, void, off_A {} > undrl {})
| selftests::offset_type::CHECK_VALID (false, void, off_A {}<=undrl {})
| selftests::offset_type::CHECK_VALID (false, void, off_A {} >=undrl {})
static void | selftests::offset_type::run_tests ()
void | _initialize_offset_type_selftests ()

## Variables
off_A | selftests::offset_type::lval_a {}
off_B | selftests::offset_type::lval_b {}

## Macro Definition Documentation

## ◆ CHECK_VALID

#define CHECK_VALID | ( |  | VALID,
|  |  | EXPR_TYPE,
|  |  | EXPR
| ) |  | CHECK_VALID_EXPR_2 (off_A, off_B, VALID, EXPR_TYPE, EXPR)

Definition at line 41 of file offset-type-selftests.c.

## Function Documentation

## ◆ _initialize_offset_type_selftests()

void _initialize_offset_type_selftests | ( |  | ) |

Definition at line 175 of file offset-type-selftests.c.

References selftests::register_test(), and selftests::offset_type::run_tests().